# Supported Parameters

We support a range of parameters, that allow you to fine-tune request behavior by enabling JS Rendering, geotargeting, sending custom headers, using sticky IPs, device emulation, residential proxies, advanced unblocking mechanisms and more. These help you scrape domains with stricter protection.

| Parameter           | Description                                                                                                                                                                                                                                                                                                                                              |
| ------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `render`            | <p>Activate JavaScript rendering by setting <code>render=true</code> in your request. The API will automatically render the JavaScript on the page and return the HTML response after the JS content has been rendered.</p><p>Requests using this parameter cost 10 API credits, or 75 if used in combination with <code>ultra\_premium=true</code>.</p> |
| `wait_for_selector` | The `wait_for_selector` parameter instructs the API to wait until a specific element appears on the page before returning the response. This parameter **must be used** in combination with `render=true` and will not work if specified on its own.                                                                                                     |
| `screenshot`        | **`screenshot=true` -** Gives you the ability to take a screenshot of the target page. This parameter automatically enables JS rendering to get the full page content, before a screenshot is taken.                                                                                                                                                     |
| `country_code`      | Activate country geotargeting. For example setting `country_code=us` will instruct the API to use US proxies. You can find list of supported countries [here](/control-and-optimization/geotargeting.md). This parameter does not increase the cost of the API request.                                                                                  |
| `premium`           | Activate residential and mobile IPs by setting `premium=true`. Using premium proxies costs 10 API credits, or 25 API credits if used in combination with JavaScript rendering `render=true`. **(Can not be combined with** `ultra_premium`**)**.                                                                                                         |
| `ultra_premium`     | <p>Activate our advanced bypass mechanisms by setting <code>ultra\_premium=true</code>.</p><p>Requests using this parameter cost 30 API credits, or 75 if used in combination with JavaScript rendering. <strong>(Can not be combined with</strong> <code>premium</code><strong>)</strong>.</p>                                                          |
| `session_number`    | <p>Reuse the same proxy by setting <code>session\_number=123</code> for example.</p><p>This parameter does not increase the cost of the API request. <strong>(Can not be combined with</strong> <code>premium/ultra\_premium</code><strong>)</strong>.</p>                                                                                               |
| `keep_headers`      | <p>Tell the API to use your custom headers with the request by setting <code>keep\_headers=true</code> .</p><p>This parameter does not increase the cost of the API request.</p>                                                                                                                                                                         |
| `device_type`       | <p>Set your requests to use mobile or desktop User Agent by setting <code>device\_type=desktop</code> (default) or <code>device\_type=mobile</code>.</p><p>This parameter does not increase the cost of the API request.</p>                                                                                                                             |
| `autoparse`         | <p>Activate auto parsing for <a href="/pages/NbQNy3NIXJCvK0z3nwfy">selected</a> websites by setting <code>autoparse=true</code>. The API will parse the data on the page and return it in JSON format.</p><p>This parameter does not increase the cost of the API request.</p>                                                                           |
| `output_format`     | <p>The <code>output\_format</code> parameter allows you to instruct the API on what the response file type should be. Valid options:</p><p></p><ul><li>markdown</li><li>text</li></ul><p></p><p><a href="/pages/NbQNy3NIXJCvK0z3nwfy">SDEs</a> valid options:</p><ul><li>json</li><li>csv</li><li>markdown</li><li>text</li></ul>                        |
| `follow_redirect`   | This parameter tells our API if you want to follow a redirect that a website might respond with. Default value is `true`. This parameter does not increase the cost of the API request.                                                                                                                                                                  |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.scraperapi.com/control-and-optimization/supported-parameters.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
